package org.japura.task.ui;

import javax.swing.SwingUtilities;

import org.japura.Application;
import org.japura.task.Task;
import org.japura.util.InputEventBlocker;

/**
 * <P>
 * Copyright (C) 2011-2012 Carlos Eduardo Leite de Andrade
 * <P>
 * This library is free software: you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 * <P>
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * <P>
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program. If not, see <A
 * HREF="www.gnu.org/licenses/">www.gnu.org/licenses/</A>
 * <P>
 * For more information, contact: <A HREF="www.japura.org">www.japura.org</A>
 * <P>
 * 
 * @author Carlos Eduardo Leite de Andrade
 */
public class InputEventBlockerUI implements TaskExecutionUI{

  private InputEventBlocker eventHook = new InputEventBlocker();

  @Override
  public void submitted(Task<?> task) {
	if (SwingUtilities.isEventDispatchThread()
		&& Application.getTaskManager().getQueueCount() == 1) {
	  setEnabled(true);
	}
  }

  @Override
  public void beforeExecute(Task<?> task) {}

  @Override
  public void afterExecute(Task<?> task) {
	if (Application.getTaskManager().getQueueCount() == 0) {
	  setEnabled(false);
	}
  }

  protected void setEnabled(boolean enabled) {
	if (enabled) {
	  eventHook.apply();
	} else {
	  eventHook.remove();
	}
  }

}
